
(function(){
    var A_INTERFACE_URL = '<{$base_url}>';
    //var A_INTERFACE_URL = 'http://t1.4399sj.com:8089/cn/'; //'http://a.4399.cn/';
    var key = '<{$count_key}>';

    function jsonp(url, success, failure){
        var script = document.createElement("script"),
            calbackname = 'JSONP' + (new Date() - 0);

        success = typeof success === 'function' ? success : function(){};
        failure = typeof failure === 'function' ? failure : function(){};

        window[calbackname] = success;

        script.onload = function(e){
            document.body.removeChild(script);
            delete window[calbackname];
        }

        script.onerror = function(e){
            failure();
            document.body.removeChild(script);
            delete window[calbackname];
        }

        if(url.indexOf("?") >= 0){
            url += '&_callback_=' + calbackname;
        } else {
           url += '?_callback_=' + calbackname;
        }

        script.src = url;

        document.body.appendChild(script);
    }


    jsonp(A_INTERFACE_URL + 'service/counter.html?key=' + key, function(data){
        if(data.code == 100 && data.result && data.result.num > 0){
            document.getElementById('j-counter_num').innerHTML = data.result.num;
            document.getElementById('j-counter').style.display = 'inline';
        }
    });

    var imgs = document.querySelectorAll(".showImg");
    for(var i = 0; i < imgs.length; i++){
        imgs[i].style.width = window.innerWidth + "px";
    }

function setFontSize(size){
    document.body.style.fontSize = size;
}

    /*
   * 需求说明  ： 需求3.5版本
   * */

    function ShowMaxLine7(item){
        /*
        * 大于7行的判断
        * 隐藏 展开更多
        * 点击展开更多
        *
        *
        * 原理 每行 长度 / fontSize 看一行可以放多少个字
        * */
        this.maxLine = 7;
        this.item = item;
        this.itemText = this.item.innerHTML;
        this.infoMore = this.getNextElement(this.item);
        this.infoMoreBtn = this.infoMore.getElementsByTagName('span')[0];
        this.getComputedStyle = window.getComputedStyle(this.item,null);
        this.commentHeight = this.getCommentHeight();
        this.itemWith = parseFloat(this.getComputedStyle.width);
        this.fontSize = parseFloat(this.getComputedStyle.fontSize);
        this.everLineFontCount = parseInt(this.itemWith / this.fontSize);  //每行显示多少个字
        this.allFontCout = this.everLineFontCount * this.maxLine; //最多显示多少个字
        this.maxHeight = this.getMaxHeight();
        this.init();
    }



    ShowMaxLine7.prototype.init = function () { //初始化
        this.limitHeight();
    };

    ShowMaxLine7.prototype.limitHeight = function () { //初始化
        if(this.commentHeight >  this.maxHeight && (this.itemText.length > 155)){
            this.item.style.height = this.maxHeight + 'px';
            this.showInfoMoreBtn();
            this.replaceText();
        }
    };

    ShowMaxLine7.prototype.replaceText = function () { //替换文字
        this.newContent = this.itemText.slice(0,this.allFontCout - 1) + '...';
        this.item.innerHTML = this.newContent;
    };

    ShowMaxLine7.prototype.showAllText = function () { //替换文字
        this.item.innerHTML = this.itemText;
    };



    ShowMaxLine7.prototype.event = function () { //事件添加
        var _this = this;
        /*    this.infoMoreBtn.onclick = function () {
                _this.showAllInfoMoreContent();
            }*/
    };

    ShowMaxLine7.prototype.getLineHeight = function () { //获取每行高度
        var height = this.getComputedStyle.lineHeight;
        return parseFloat(height);
    };

    ShowMaxLine7.prototype.getMaxHeight = function () {  //获取限定高度
        return this.getLineHeight() * this.maxLine;
    };

    ShowMaxLine7.prototype.getCommentHeight = function () {  //获取评论搞定高度
        return parseFloat(this.getComputedStyle.height);
    };

    ShowMaxLine7.prototype.getNextElement = function (obj) {  //获取限定高度
        return obj.nextElementSibling;
    };

    ShowMaxLine7.prototype.showInfoMoreBtn = function () { // 显示展开更多的按钮
        this.infoMore.style.display = 'block';
    };

    ShowMaxLine7.prototype.hideInfoMoreBtn = function () { // 隐藏展开更多的按钮
        this.infoMore.style.display = 'none';
    };


    ShowMaxLine7.prototype.showAllInfoMoreContent = function () { //显示更多内容
        this.item.style.height = null;
        this.hideInfoMoreBtn();
        this.showAllText();
    };

window.M_Comment = function(aid, pid, pname, autoLoadMore, showCommentForm, newCommentScrollTop){
    this.pl_total = -1;
    this.pl_page = 1;
    this.is_load_over = false;
    this.firstLoadNum = 6;//第一页加载6条
    this.loadPerNum = 10;//后续每页加载10条
    this.comments = [];
    this.aid = aid;
    this.pid = pid;
    this.pname = pname;
    this.showCommentForm = showCommentForm === false ? false : true;
    this.newCommentScrollTop = newCommentScrollTop;
    this.autoLoadMore = autoLoadMore;// === true ? true : false;
    //this.init();
}

var classList = {
    contains : function(obj, cls){
        return obj.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
    },

    add : function(obj, cls){
        if (!this.contains(obj, cls)) obj.className += " " + cls;

    },

    remove : function(obj, cls){
        if (this.contains(obj, cls)) {
            var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
            obj.className = obj.className.replace(reg, ' ');
        }
    }
}

M_Comment.prototype = {

    init : function(type){
        var type = type || false;
        var mcomment = this,
            mpage = document.getElementsByTagName("body")[0],
            j_comment = document.getElementById('j-comment'),
            tmpl = '\
                <div class="comment_hd '+ (type ? "comment_new_hd" : "") +'">\
                    <h3 class="m_title '+ (type ? "n_title" : "") +'">用户评论</h3>\
                    <span class="count"><b id="j-comment_count">0</b>条评论</span>\
                </div>\
                <div class="comment_main">\
                    <ul class="comment_list" id="j-comment_list"></ul>\
                    <div class="load_more hashover load_more_comment loading" id="j-load_more_comment">评论加载中...</div>\
                </div>\
                <div class="v_comment_form clearfix j-v_comment_form" ' + (mcomment.showCommentForm ? '' : 'style="display:none"') + '> <i class="ico_comment j-v_comment_form"></i>\
                    <div class="textarea j-v_comment_form">我也说两句…</div>\
                </div>';

        j_comment.innerHTML = tmpl;
        var touchstart = false;

        mpage.addEventListener("touchstart", function(e){
            var _this = e.target;

            if (classList.contains(_this, "hashover")){
                 classList.add(_this, "hover");
            } else if(classList.contains(_this.parentNode, "hashover")){
                classList.add(_this.parentNode, "hover");
            }
            touchstart = true;
            e.preventDefault;
        }, true);

        mpage.addEventListener("touchmove", function(e){
            var _this = e.target;
            if (classList.contains(_this, "hashover")){
                 classList.remove(_this, "hover");
            } else if(classList.contains(_this.parentNode, "hashover")){
                classList.remove(_this.parentNode, "hover");
            }
            touchstart = false;
        }, true);

        mpage.addEventListener("touchcancel", function(e){
            var _this = e.target;
            if (classList.contains(_this, "hashover")){
                 classList.remove(_this, "hover");
            } else if(classList.contains(_this.parentNode, "hashover")){
                classList.remove(_this.parentNode, "hover");
            }
        }, true);

        mpage.addEventListener("touchend", function(e){
            var _this = e.target;
            if (classList.contains(_this, "hashover")){
                 classList.remove(_this, "hover");
            } else if(classList.contains(_this.parentNode, "hashover")){
                classList.remove(_this.parentNode, "hover");
            }

            if(!touchstart) return;
            mcomment.handleEvent(e);
        }, true);

        if(mcomment.autoLoadMore === true){

            window.addEventListener("scroll", function(){
                var v_height = window.innerHeight || document.documentElement.clientHeight;

                //alert('mpage.offsetHeight:' + mpage.offsetHeight + 'window.scrollY:' + window.scrollY + 'v_height:' + v_height);
                if ( mpage.offsetHeight - window.scrollY <= v_height * 1.5){
                    //alert("autoLoadMore");
                    mcomment.handleEvent({
                        target : document.getElementById('j-load_more_comment')
                    });
                }
            }, false);
        }

        mcomment.showComments(1);
    },

    handleEvent : function(e){
        var mcomment = this,
            _this = e.target;

        if(_this.id == 'j-load_more_comment'){
            if(typeof mcomment.autoLoadMore === 'function'){
                mcomment.autoLoadMore.call(mcomment);
                return false;
            }

            var p = parseInt(_this.getAttribute("data-page")) || 1;

            if (classList.contains(_this, "nodata") || classList.contains(_this, "loading")){
                return false;
            }

            classList.add(_this, "loading");
            _this.innerHTML = "正在加载更多数据...";
            p++;

            _this.setAttribute("data-page", p);
            mcomment.showComments(p);
            return false;
        } else if(classList.contains(_this, "load_more_reply")){
            var cid = _this.getAttribute("data-cid"),
                reply_list = document.getElementById("reply_list_" + cid),
                end = parseInt(reply_list.getAttribute("data-end")),
                reply_lis = reply_list.getElementsByTagName("li"),
                next = Array.prototype.slice.call(reply_lis, end, end + 10);

            next.forEach(function(v, i){
                v.style.display = "block";
            })

            reply_list.setAttribute("data-end", end + 10);
            if(next.length < 10){
                _this.style.display = "none";
            }

            mcomment.onresize();

        } else if(classList.contains(_this, "j-v_comment_form")){
            //alert('在这里调用发布评论表单');
            //添加一条新评论
            android.onClickAddComment();
            //comment.newComment("新添加的评论", 4);
        } else if(classList.contains(_this, "btn_reply")){
            var cid = _this.getAttribute('data-cid');
            //alert('在这里调用发布回复表单' + cid);
            //添加一条新回复
            android.onClickReplyComment(cid);
            //comment.newReply(cid,'昵称','一条新的回复内容');
        }  else if(classList.contains(_this.parentNode, "btn_reply")){
            var cid = _this.parentNode.getAttribute('data-cid');
            //alert('在这里调用发布回复表单' + cid);
            //添加一条新回复
            android.onClickReplyComment(cid);
            //comment.newReply(cid,'昵称','一条新的回复内容');
        }
    },

    checkNoComments : function(code, page){
        var _this = this,
            load_more_comment = document.getElementById("j-load_more_comment");

        if (code == 0){
            classList.remove(load_more_comment, "loading");
            classList.add(load_more_comment, "nodata");
            load_more_comment.innerHTML = "暂无更多评论";

            if (this.comments.length == 0){
                load_more_comment.innerHTML = "快来抢沙发~";
                return;
            }

            if (page == 1){
                 classList.add(load_more_comment, "nodata_visible");
            }
        } else {
            classList.remove(load_more_comment, "loading");
            load_more_comment.innerHTML = "点击查看更多评论";
        }
    },

    getComments : function(callback){
        var mcomment = this,
            F_ID = mcomment.aid,
            F_DIR = F_ID % 10000;

        var script = document.createElement("script");

        script.onload = function(e){
            mcomment.loadCommentSuccess(callback);
            document.body.removeChild(script);
        }

        script.onerror = function(e){
            mcomment.loadCommentError();
            document.body.removeChild(script);
        }

        script.src = 'http://comment.5054399.com/' + mcomment.pname + '/' + F_DIR + '/' + F_ID+'_' + mcomment.pl_page + '_js.html';
        document.body.appendChild(script);
    },

    loadCommentSuccess : function(callback){
        var mcomment = this,
            F_ID = mcomment.aid,
            F_DIR = F_ID % 10000;

        try{
            content = content || [];
        } catch(e){
            mcomment.loadCommentError();
            return;
        }


        var comments = [];

        for (var i = 0; i < content.length; i++) {

            var comment = {
                'avatar' : 'http://a.img4399.com/' + content[i]["uid"] + '/small',
                'content' : mcomment.parseContent(content[i]['comment']),
                'id' : content[i]['id'],
                'star' : content[i].star * 2,
                'nick' : mcomment.parseNick(content[i]["uid"], content[i]["ip"], content[i]["username"]),
                'created' : mcomment.parseDate(content[i]['time']),
                'reply' : [],
                'good' : content[i]['good'],
                'from' : mcomment.parseDevice(content[i]['channel'], content[i]['user_agent']),
                'uid' : content[i]['uid']
            };

            if(content[i].reply){
                //格式化回复
                for( var k = 0; k < content[i].reply.length; k++){

                    var reply = {
                        'avatar' : 'http://a.img4399.com/' + content[i]['reply'][k]["uid"] + '/small',
                        'content' : mcomment.parseContent( content[i]['reply'][k]['reply'] ),
                        'nick' : mcomment.parseNick( content[i]['reply'][k]["uid"], content[i]['reply'][k]["ip"], content[i]['reply'][k]["username"] ),
                        'created' : mcomment.parseDate( content[i]['reply'][k]['time'] )
                    };

                    comment['reply'][k] = reply;
                }
            }

            comments.push(comment);
        }

        Array.prototype.push.apply(mcomment.comments, comments);

        //第一次加载时
        if(mcomment.pl_page == 1){
            mcomment.pl_total = num;
            document.getElementById("j-comment_count").innerHTML = num;
        }

        mcomment.pl_page++;

        var code = 1;
        if (content.length < 20){
            code = 0;
        }

        typeof callback === "function" && callback.call(mcomment, code);
    },

    parseDevice : function(channel, user_agent){
        if(typeof channel === "undefined"){
            return '';
        }
        var from = '4399.cn';

        if (channel == 2 || channel == 1){
            from = user_agent;
            if(!user_agent){
                from = '4399游戏盒'
            }
        }

        return from;
    },

    loadCommentError : function(){
        var mcomment = this,
            load_more_comment = document.getElementById("j-load_more_comment");

        if(mcomment.pl_total > 0){
            classList.remove(load_more_comment, "loading");
            classList.add(load_more_comment, "nodata");
            load_more_comment.innerHTML = "暂无更多评论";
        } else {
            load_more_comment.innerHTML = "快来抢沙发~";
        }
    },

    parseDate : function(timeu){
        var timestatus = timeu.split(" ")[0];
        var nowYear = (new Date()).getFullYear();
        var nowDate = (new Date()).toLocaleDateString().split("/").join("-");
        if(nowDate == timestatus){
            return timeu.split(" ")[1];
        }
        return timestatus.split("-")[0] == nowYear ? (timestatus.split("-")[1]+"-"+timestatus.split("-")[2]) : timestatus;
    },

    parseContent : function(comment){
        if(typeof comment !== "string") return "";

        comment = comment.replace(/src=["']?(\/images(\/\w+)?\/\d+\.gif)["']?/gi, function(all, key){
            return 'src=http://comment.5054399.com' + key;
        });

        return comment.trim();
    },

    parseNick : function(uid, ip, username){
        var nick = username;

        if (uid == 0){
            if(ip == "未知"){
                nick = "4399网友";
            } else {
                nick = '4399' + ip + "网友";
            }
        }

        return nick;
    },

    checkCache : function(end_i, callback){
        var _this = this;

        //缓存数据不够
        if (_this.comments.length <= end_i && !_this.is_load_over){
            _this.getComments(function(code){
                if (_this.comments.length == _this.pl_total && _this.pl_total >= 0){
                    _this.is_load_over = true;//评论已经全部加载完
                    typeof callback === "function" && callback.call(_this);
                    return;
                }

                if (code == 0){
                    _this.is_load_over = true;//评论已经全部加载完
                    typeof callback === "function" && callback.call(_this);
                } else {
                    _this.checkCache(end_i, callback);
                }
            });
        } else {//缓存数据充足
            typeof callback === "function" && callback.call(_this);
        }
    },

    showComments : function(page, callback){
        var _this = this,
            start_i,
            end_i;

        if (page == 1){
            start_i = 0;
            end_i = _this.firstLoadNum;
        } else {
            start_i = (page - 2) * _this.loadPerNum + _this.firstLoadNum;
            end_i = (page - 1) * _this.loadPerNum + _this.firstLoadNum;
        }

        _this.checkCache(end_i, function(){
            //最后一页
            var code = 1;
            if (_this.comments.length <= end_i){
                code = 0;
            }

            var comments = Array.prototype.slice.call(_this.comments, start_i, end_i);
            var comment_list = document.getElementById("j-comment_list");
            _this.renderCommentList(comment_list, comments);
            //头像点击事件
            var userhead = document.querySelectorAll(".userhead");
            for(var i = 0 ; i<userhead.length; i++){
                userhead[i].onclick = function(){
                    var uid = +this.getAttribute("data-uid");
                    var nickName = this.parentNode.querySelectorAll(".fl")[0].querySelectorAll(".nick")[0].innerHTML;
                    var clickType = 2;//2来自资讯详情页面
                    if(uid){
                        var dataJson = {uid:uid,nickName:nickName,clickType:clickType};
                        dataJson = JSON.stringify(dataJson);
                        android.onClickUserPortraitByComment(dataJson);
                    }
                };
            }
            _this.checkNoComments(code, page);
        });
    },

    renderCommentList : function(target, comments){
        var _this = this;

        for (var i = 0; i < comments.length; i++){
            var dom = _this.renderComment(comments[i]);
            dom = Array.prototype.slice.call(dom, 0);
            dom.forEach(function(v, i){
                target.appendChild(v);
                var item =  v.getElementsByClassName('content')[0];
                if(item){
                    item.showMaxLine7 = new ShowMaxLine7(item);
                }
            });
        }

        _this.onresize();
    },

    renderComment : function(item){
        var html = '',
            reply,
            li,
            border,
            visitor = '';

        li = document.createElement("li");
        li.className = "item j-commentlist";
        li.id = "comment_id_" + (item.id || 0);
        if(!(+item.uid)){
            visitor = 'visitor';
        }
		html += '<div class="clearfix">\
			<img src="'+ item.avatar +'" class="avatar userhead '+ visitor +'" data-uid="'+ item.uid +'" >\
			<span class="fl">\
				<span class="nick">'+ item.nick +'</span>';

		if(item.good == 1){
			html += '<span class="essence"><i></i>精彩评论</span>';
		}

		html += '<span class="created">'+ item.created +'</span><span class="star"><span class="star_'+ item.star +'"></span></span></span>';

		html += '</div>\
				<div class="content">'+ item.content +'</div>\
				<div class="info_more"><b class="j-info-more-btn">展开全部</b></div>\
				<div class="clearfix">';

		if(item.from && item.from != ''){
			if(item.from == "4399.cn"){
				html += '<span class="from fl fromPC">4399.cn</span>'
			}else{
				html += '<span class="from fl">'+ item.from +'</span>'
			}
		}

		if(item.id > 0) {
			html += '<span class="btn_reply fr hashover" data-cid="'+ item.id +'"><i></i><span>回复</span></span>';
		}

		html += '</div>\
				<div class="reply_list" id="reply_list_'+ (item.id || 0) +'" data-end="5" '+ (item.reply.length == 0 ? 'style="display: none"' : '') +'>\
					<ul>';

		for (var k = 0; k < item.reply.length; k++){
			reply =  item.reply[k];
			html += '<li class="reply" '+ (k >= 5 ? 'style="display: none"' : '') +'>\
						<dl class="reply_meta">\
							<dt class="reply_nick">'+ reply.nick +'：</dt>\
							<dd class="reply_content">'+ reply.content +'</dd>\
						</dl>\
					</li>';
		}

        html += '</ul>' +
                    (item.reply.length > 5 ? '<div class="load_more hashover load_more_reply" data-cid="' + item.id + '">点击查看更多回复</div>' : '' ) +
                '</div>';

        li.innerHTML = html;

        border = document.createElement("li");
        border.className = 'light_line_bottom';
        return [li, border];
    },

    newComment : function(content, star, nick, avatar, channel, user_agent){
        var _this = this,
            load_more_comment = document.getElementById("j-load_more_comment"),
            comment_list = document.getElementById("j-comment_list"),
            comment_lis = comment_list.getElementsByClassName('item');

        var comment = {
            'avatar' : avatar || 'http://a.img4399.com/0/small',
            'content' : content + '<p style="color:#ff6600">您的评论正在审核中，请耐心等待...</p>',
            'created' : '刚刚',
            'nick' : nick || '4399网友',
            'star' : star * 2,
            'reply' : [],
            'from' : _this.parseDevice(channel, user_agent)
        };


        var dom = _this.renderComment(comment);
        dom = Array.prototype.slice.call(dom, 0);

        if (comment_lis.length == 0){
            classList.remove(load_more_comment, "loading");
            classList.add(load_more_comment, "nodata");
            load_more_comment.innerHTML = "恭喜您抢到了沙发~";
            dom.forEach(function(v, i){
                comment_list.appendChild(v);
            });
        } else {
            dom.reverse();
            var first_node = comment_lis[0];

            dom.forEach(function(v, i){
                comment_list.insertBefore(v, first_node);
                first_node = v;
                var item = v.getElementsByClassName('content')[0];

                if(item){
                    item.showMaxLine7 = new ShowMaxLine7(item);
                }
            });
        }

        _this.onresize();
        if(_this.newCommentScrollTop){
            window.scrollTo(0, comment_list.offsetTop);
        }

    },

    newReply : function(cid, content, nick, avatar, channel, user_agent){
        var reply_list = document.getElementById("reply_list_" + cid),
            ul,
            lis,
            html,
            li,
            _this = this;

        nick = nick || '4399网友';

        if(reply_list){
            ul = reply_list.getElementsByTagName("ul")[0];
            lis = ul.getElementsByClassName("reply");

            html = '<dl class="reply_meta">\
                        <dt class="reply_nick">' + nick + '：</dt>\
                        <dd class="reply_content">' + content + '</dd>\
                    </dl>';
            li = document.createElement("li");
            li.className = "reply";
            li.innerHTML = html;

            if(lis.length == 0){
                reply_list.style.display = "block";
                ul.appendChild(li);
            } else {
                ul.insertBefore(li, lis[0]);
            }

            _this.onresize();


        }
    },

    async : function(url, success, failure){
        var script = document.createElement("script"),
            calbackname = 'JSONP' + (new Date() - 0);

        success = typeof success === 'function' ? success : function(){};
        failure = typeof failure === 'function' ? failure : function(){};

        window[calbackname] = success;

        script.onload = function(e){
            document.body.removeChild(script);
            delete window[calbackname];
        }

        script.onerror = function(e){
            failure();
            document.body.removeChild(script);
            delete window[calbackname];
        }

        if(url.indexOf("?") >= 0){
            url += '&callback=' + calbackname;
        } else {
           url += '?callback=' + calbackname;
        }

        script.src = url;

        document.body.appendChild(script);
    },

    onresize : function(){
        //alert("页面高度发生变化了，新的页面高度是：" + document.getElementById("container").offsetHeight + "px");
        //如果获取的高度不太准确可以加个setTimeout(),再去调用页面的高度
        return;
        document.getElementById("container").style.height = "auto";
        setTimeout(function(){
            document.getElementById("container").style.height = document.getElementById("container").offsetHeight + "px";
        }, 200);
    }
}
var _imgObject = document.querySelectorAll('img');
		var _cw = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
		window.addEventListener('load',function(){
			for( var i=0,len=_imgObject.length;i<len;i++){
				if( _imgObject[i].naturalWidth && _imgObject[i].naturalWidth > 320 ){
					_imgObject[i].setAttribute('width',_cw-20);
				}
			}
		});

    document.body.addEventListener("click",function(e){
        var e = e || window.event;
        if(e.target.className == "j-info-more-btn"){
            var item  = e.toElement.parentNode.previousElementSibling;
            item.showMaxLine7.showAllInfoMoreContent();
            return false;
        }
    });
})();
